﻿using System;
using GalaSoft.MvvmLight.Threading;
using Microsoft.Devices.Sensors;

namespace CompassSample.Model
{
    public class SensorService : ISensorService
    {
        private Action<double> _orientationCallback;
        private Compass _compass;

        public void RegisterForHeading(Action<double> callback)
        {
            _orientationCallback = callback;

            if (_compass == null)
            {
                _compass = new Compass();
                _compass.CurrentValueChanged += CompassCurrentValueChanged;
                _compass.Start();
            }
        }

        void CompassCurrentValueChanged(object sender, SensorReadingEventArgs<CompassReading> e)
        {
            if (_orientationCallback != null)
            {
                _orientationCallback(e.SensorReading.TrueHeading);
            }
        }
    }
}